VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "GDI+: Font aus Ressource oder Fontdatei verwenden"
   ClientHeight    =   1815
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   6150
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1815
   ScaleWidth      =   6150
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picRes 
      Height          =   1695
      Left            =   60
      ScaleHeight     =   1635
      ScaleWidth      =   5955
      TabIndex        =   0
      Top             =   60
      Width           =   6015
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' ----==== Const ====----
Private Const LANG_NEUTRAL As Long = &H0
Private Const LF_FACESIZE As Long = 32
Private Const GdiPlusVersion As Long = &H1&

' ----==== Types ====----
Private Type GDIPlusStartupInput
    GdiPlusVersion As Long
    DebugEventCallback As Long
    SuppressBackgroundThread As Long
    SuppressExternalCodecs As Long
End Type

Private Type GdiplusStartupOutput
    NotificationHook As Long
    NotificationUnhook As Long
End Type

Private Type RECTF
    Left As Single
    Top As Single
    Width As Single
    Height As Single
End Type

' ----==== Enums ====----
Private Enum Status
    OK = 0
    GenericError = 1
    InvalidParameter = 2
    OutOfMemory = 3
    ObjectBusy = 4
    InsufficientBuffer = 5
    NotImplemented = 6
    Win32Error = 7
    WrongState = 8
    Aborted = 9
    FileNotFound = 10
    ValueOverflow = 11
    AccessDenied = 12
    UnknownImageFormat = 13
    FontFamilyNotFound = 14
    FontStyleNotFound = 15
    NotTrueTypeFont = 16
    UnsupportedGdiplusVersion = 17
    GdiplusNotInitialized = 18
    PropertyNotFound = 19
    PropertyNotSupported = 20
    ProfileNotFound = 21
End Enum

Private Enum Unit
    UnitWorld = &H0
    UnitDisplay = &H1
    UnitPixel = &H2
    UnitPoint = &H3
    UnitInch = &H4
    UnitDocument = &H5
    UnitMillimeter = &H6
End Enum

Private Enum FontStyle
    FontStyleRegular = &H0
    FontStyleBold = &H1
    FontStyleItalic = &H2
    FontStyleBoldItalic = &H3
    FontStyleUnderline = &H4
    FontStyleStrikeout = &H8
End Enum

Private Enum StringFormatFlags
    StringFormatFlagsDefault = &H0
    StringFormatFlagsDirectionRightToLeft = &H1
    StringFormatFlagsDirectionVertical = &H2
    StringFormatFlagsNoFitBlackBox = &H4
    StringFormatFlagsDisplayFormatControl = &H20
    StringFormatFlagsNoFontFallback = &H400
    StringFormatFlagsMeasureTrailingSpaces = &H800
    StringFormatFlagsNoWrap = &H1000
    StringFormatFlagsLineLimit = &H2000
    StringFormatFlagsNoClip = &H4000
End Enum

Private Enum TextRenderingHint
    TextRenderingHintSystemDefault = &H0
    TextRenderingHintSingleBitPerPixelGridFit = &H1
    TextRenderingHintSingleBitPerPixel = &H2
    TextRenderingHintAntiAliasGridFit = &H3
    TextRenderingHintAntiAlias = &H4
    TextRenderingHintClearTypeGridFit = &H5
End Enum

Private Enum SmoothingMode
    SmoothingModeInvalid = &HFFFFFFFF
    SmoothingModeDefault = &H0
    SmoothingModeHighSpeed = &H1
    SmoothingModeHighQuality = &H2
    SmoothingModeNone = &H3
    SmoothingModeAntiAlias = &H4
End Enum

' ----==== Kernel32.dll Deklarationen ====----
Private Declare Sub CopyMemory Lib "Kernel32" _
                    Alias "RtlMoveMemory" ( _
                    ByRef pDest As Long, _
                    ByRef pSource As Long, _
                    ByVal ByteLen As Long)

' ----==== Ole32.dll Deklarationen ====----
Private Declare Sub CoTaskMemFree Lib "Ole32.dll" ( _
                    ByVal pMem As Long)

Private Declare Function CoTaskMemAlloc Lib "Ole32.dll" ( _
                         ByVal cb As Long) As Long

' ----==== Oleaut32.dll Deklarationen ====----
Private Declare Function SafeArrayGetDim Lib "Oleaut32.dll" ( _
                         ByRef pArray() As Any) As Long

' ----==== Shlwapi.dll Deklarationen ====----
Private Declare Function PathFileExistsW Lib "Shlwapi.dll" ( _
                         ByVal pszFile As Long) As Long

' ----==== GdiPlus.dll Deklarationen ====----
Private Declare Function GdiplusShutdown Lib "GdiPlus.dll" ( _
                         ByVal Token As Long) As Status

Private Declare Function GdiplusStartup Lib "GdiPlus.dll" ( _
                         ByRef Token As Long, _
                         ByRef lpInput As GDIPlusStartupInput, _
                         ByRef lpOutput As GdiplusStartupOutput) As Status

Private Declare Function GdipNewPrivateFontCollection Lib "GdiPlus.dll" ( _
                         ByRef mFontCollection As Long) As Status

Private Declare Function GdipPrivateAddMemoryFont Lib "GdiPlus.dll" ( _
                         ByVal mFontCollection As Long, _
                         ByVal memory As Long, _
                         ByVal length As Long) As Status

Private Declare Function GdipPrivateAddFontFile Lib "GdiPlus.dll" ( _
                         ByVal mFontCollection As Long, _
                         ByVal mFilename As Long) As Status

Private Declare Function GdipDeletePrivateFontCollection Lib "GdiPlus.dll" ( _
                         ByRef mFontCollection As Long) As Status

Private Declare Function GdipCreateFont Lib "GdiPlus.dll" ( _
                         ByVal mFontFamily As Long, _
                         ByVal mEmSize As Single, _
                         ByVal mStyle As FontStyle, _
                         ByVal mUnit As Unit, _
                         ByRef mFont As Long) As Status

Private Declare Function GdipCreateFontFamilyFromName Lib "GdiPlus.dll" ( _
                         ByVal mName As Long, _
                         ByVal mFontCollection As Long, _
                         ByRef mFontFamily As Long) As Status

Private Declare Function GdipDeleteFont Lib "GdiPlus.dll" ( _
                         ByVal mFont As Long) As Status

Private Declare Function GdipDeleteFontFamily Lib "GdiPlus.dll" ( _
                         ByVal mFontFamily As Long) As Status

Private Declare Function GdipCreateFromHDC Lib "GdiPlus.dll" ( _
                         ByVal mhDC As Long, _
                         ByRef mGraphics As Long) As Status

Private Declare Function GdipDeleteGraphics Lib "GdiPlus.dll" ( _
                         ByVal mGraphics As Long) As Status

Private Declare Function GdipDrawString Lib "GdiPlus.dll" ( _
                         ByVal mGraphics As Long, _
                         ByVal mString As Long, _
                         ByVal mLength As Long, _
                         ByVal mFont As Long, _
                         ByRef mLayoutRect As RECTF, _
                         ByVal mStringFormat As Long, _
                         ByVal mBrush As Long) As Status

Private Declare Function GdipCreateSolidFill Lib "GdiPlus.dll" ( _
                         ByVal mColor As Long, _
                         ByRef mBrush As Long) As Status

Private Declare Function GdipDeleteBrush Lib "GdiPlus.dll" ( _
                         ByVal mBrush As Long) As Status

Private Declare Function GdipCreateStringFormat Lib "GdiPlus.dll" ( _
                         ByVal mFormatAttributes As StringFormatFlags, _
                         ByVal mLanguage As Long, _
                         ByRef mFormat As Long) As Status

Private Declare Function GdipDeleteStringFormat Lib "GdiPlus.dll" ( _
                         ByVal mFormat As Long) As Status

Private Declare Function GdipSetTextRenderingHint Lib "GdiPlus.dll" ( _
                         ByVal mGraphics As Long, _
                         ByVal mMode As TextRenderingHint) As Status

Private Declare Function GdipSetSmoothingMode Lib "GdiPlus.dll" ( _
                         ByVal mGraphics As Long, _
                         ByVal mSmoothingMode As SmoothingMode) As Status

Private Declare Function GdipGetFontCollectionFamilyCount Lib "GdiPlus.dll" ( _
                         ByVal mFontCollection As Long, _
                         ByRef mNumFound As Long) As Status

Private Declare Function GdipGetFontCollectionFamilyList Lib "GdiPlus.dll" ( _
                         ByVal mFontCollection As Long, _
                         ByVal mNumSought As Long, _
                         ByVal mFamilies As Long, _
                         ByRef mNumFound As Long) As Status

Private Declare Function GdipGetFamilyName Lib "GdiPlus.dll" ( _
                         ByVal mFamily As Long, _
                         ByVal mName As Long, _
                         ByVal mLanguage As Long) As Status

' ----==== Variablen ====----
Private m_Init As Boolean
Private m_GdipToken As Long
Private m_PrivateFontCollection As Long

Private Sub Form_Load()
    
    Dim sInfo As String
    Dim sFontFamilyName As String
    
    m_Init = False
    
    ' GDI+ starten
    If StartUpGDIPlus(m_GdipToken) = OK Then
    
        ' PrivateFontCollection-Objekt erstellen
        If GdipNewPrivateFontCollection(m_PrivateFontCollection) = OK Then
                
            m_Init = True
            
            ' Fonts aus einer Ressource laden und dem FontCollection-Objekt hinzufgen
            Call LoadFontFromRes(101, "Font", m_PrivateFontCollection)
            Call LoadFontFromRes(102, "Font", m_PrivateFontCollection)
            
            ' und/oder Fonts aus einer Datei laden und dem FontCollection-Objekt hinzufgen
            'Call LoadFontFromFile(App.Path & "\Dingleberries.ttf", m_PrivateFontCollection)
            'Call LoadFontFromFile(App.Path & "\DSEG14Classic.ttf", m_PrivateFontCollection)
            
            sInfo = sInfo & "Anzal der Fonts in der PrivateFontCollection = " & _
                CStr(GetFontCollectionFamilyCount(m_PrivateFontCollection)) & vbNewLine
            
            sInfo = sInfo & "Font von Index 0 = " & _
                GetFontFamilyNameFromCollection(0, m_PrivateFontCollection) & vbNewLine
            
            sInfo = sInfo & "Font von Index 1 = " & _
                GetFontFamilyNameFromCollection(1, m_PrivateFontCollection) & vbNewLine
            
            MsgBox sInfo, vbInformation Or vbOKOnly, "GDI+ PrivateFontCollection Demo"
            
            ' FontFamilyName von Index 0 aus dem FontCollection-Objekt ermitteln
            sFontFamilyName = GetFontFamilyNameFromCollection(0, m_PrivateFontCollection)
            
            ' ist ein FontFamilyName vorhanden
            If Len(sFontFamilyName) > 0 Then
            
                ' zeichne den Text auf ein DeviceContext
                Call DrawText("5*6=30", m_PrivateFontCollection, sFontFamilyName, _
                    50, FontStyleRegular Or FontStyleItalic)
                
            End If
            
        End If
    
    End If

End Sub

Private Sub Form_Unload(Cancel As Integer)

    ' ist eine FontCollection-Objekt vorhanden
    If m_PrivateFontCollection <> 0& Then

        ' FontCollection-Objekt lschen
        Call GdipDeletePrivateFontCollection(m_PrivateFontCollection)

    End If

    ' ist GDI+ Token vorhanden
    If m_GdipToken <> 0& Then

        ' GDI+ beenden
        Call ShutdownGDIPlus(m_GdipToken)

    End If

End Sub

Private Function LoadFontFromRes(ByVal ResID As Long, ByVal ResType As String, _
    ByVal FontCollection As Long) As Boolean

    Dim hMem As Long
    Dim bolRet As Boolean
    Dim bytFont() As Byte
    Dim lngDataSize As Long

    bolRet = False

    If m_Init = False Then Exit Function
    If FontCollection = 0& Then Exit Function

    ' Font aus der Ressource in ein ByteArray laden
    bytFont = LoadResData(ResID, ResType)

    ' ist das ByteArray dimensioniert
    If SafeArrayGetDim(bytFont) <> 0& Then

        ' gre der Daten im ByteArray
        lngDataSize = UBound(bytFont) + 1

        ' entsprechend groen Speicherbereich festlegen
        hMem = CoTaskMemAlloc(lngDataSize)

        ' ist Speicher vorhanden
        If hMem <> 0& Then

            ' ByteArray in den Speicher kopieren
            Call CopyMemory(ByVal hMem, ByVal VarPtr(bytFont(0)), lngDataSize)

            ' Fontdatei aus dem Speicher in das PrivateFontCollection-Objekt laden
            If GdipPrivateAddMemoryFont(FontCollection, hMem, lngDataSize) = OK Then

                bolRet = True

            End If

            ' Speicher wieder freigeben
            Call CoTaskMemFree(hMem)

        End If

    End If

    LoadFontFromRes = bolRet

End Function

Private Function LoadFontFromFile(ByVal FontFile As String, ByVal FontCollection _
    As Long) As Boolean

    Dim bolRet As Boolean

    bolRet = False

    If m_Init = False Then Exit Function
    If FontCollection = 0& Then Exit Function
    If Len(FontFile) = 0& Then Exit Function

    ' ist die Datei vorhanden
    If PathFileExistsW(StrPtr(FontFile)) <> 0& Then

        ' Fontdatei in das PrivateFontCollection-Objekt laden
        If GdipPrivateAddFontFile(FontCollection, StrPtr(FontFile)) = OK Then

            bolRet = True

        End If

    End If

    LoadFontFromFile = bolRet

End Function

Private Function GetFontCollectionFamilyCount(ByVal FontCollection As Long) As Long

    Dim lngRet As Long
    Dim lngCount As Long

    lngRet = 0&

    If m_Init = False Then Exit Function
    If FontCollection = 0& Then Exit Function

    ' Anzahl der FontFamilies aus dem FontCollection-Objekt ermitteln
    If GdipGetFontCollectionFamilyCount(FontCollection, lngCount) = OK Then

        lngRet = lngCount

    End If

    GetFontCollectionFamilyCount = lngRet

End Function

Private Function GetFontFamilyNameFromCollection(ByVal Index As Long, ByVal _
    FontCollection As Long) As String

    Dim strRet As String
    Dim lngCount As Long
    Dim lngRetCount As Long
    Dim lngFontFamily() As Long
    Dim bytFontName(LF_FACESIZE - 1) As Byte

    If m_Init = False Then Exit Function
    If FontCollection = 0& Then Exit Function

    ' Anzahl der FontFamilies in der FontCollection ermitteln
    lngCount = GetFontCollectionFamilyCount(FontCollection)

    ' sind FontFamilies vorhanden
    If lngCount > 0& Then

        If Index < 0 Then Index = 0
        If Index >= lngCount Then Index = lngCount - 1

        ' Array zur Aufnahme der FontFamilies dimensionieren
        ReDim lngFontFamily(lngCount - 1)

        ' FontFamily-Objekte vom FontCollection-Objekt ermitteln
        If GdipGetFontCollectionFamilyList(FontCollection, lngCount, VarPtr( _
            lngFontFamily(0)), lngRetCount) = OK Then

            ' FontFamilyName ermitteln
            If GdipGetFamilyName(lngFontFamily(Index), VarPtr(bytFontName(0)), _
                LANG_NEUTRAL) = OK Then

                ' ByteArray -> String
                strRet = CStr(bytFontName)

                lngCount = InStr(1, strRet, vbNullChar)

                If lngCount > 0 Then

                    strRet = Mid$(strRet, 1, lngCount - 1)

                End If

            End If

        End If

    End If

    GetFontFamilyNameFromCollection = strRet

End Function

Private Function GetFontFromFamilyName(ByVal FontCollection As Long, ByVal _
    FamilyName As String, Optional ByVal FontSize As Single = 10!, Optional ByVal _
    eFontStyle As FontStyle = FontStyleRegular) As Long

    Dim lngRet As Long
    Dim lngFont As Long
    Dim lngFontFamily As Long

    lngRet = 0&

    If m_Init = False Then Exit Function
    If FontCollection = 0& Then Exit Function
    If Len(FamilyName) = 0& Then Exit Function

    ' FontFamily-Objekt vom FamilyName erstellen
    If GdipCreateFontFamilyFromName(StrPtr(FamilyName), FontCollection, _
        lngFontFamily) = OK Then

        ' Font-Objekt vom FontFamily-Objekt erstellen
        If GdipCreateFont(lngFontFamily, FontSize, eFontStyle, UnitPixel, lngFont) _
            = OK Then

            lngRet = lngFont

        End If

        ' Aufrumen
        Call GdipDeleteFontFamily(lngFontFamily)

    End If

    GetFontFromFamilyName = lngRet

End Function

Private Sub DrawText(ByVal sText As String, ByVal FontCollection As Long, ByVal _
    FamilyName As String, Optional ByVal FontSize As Single = 10!, Optional ByVal _
    eFontStyle As FontStyle = FontStyleRegular)

    Dim lFont As Long
    Dim lBrush As Long
    Dim lGraphics As Long
    Dim lFontFamily As Long
    Dim lStringFormat As Long
    Dim tRECTF As RECTF

    picRes.AutoRedraw = True
    picRes.BackColor = vbWhite

    If m_Init = False Then Exit Sub
    If FontCollection = 0& Then Exit Sub
    If Len(sText) = 0& Then Exit Sub
    If Len(FamilyName) = 0& Then Exit Sub

    ' nur zur Info
    picRes.CurrentX = 60
    picRes.CurrentY = 60
    picRes.Print "Font = '" & FamilyName & "' Size = '" & _
        CStr(FontSize) & "'" & "' Text = '" & sText & "'"

    ' Font-Objekt von FontFamilyName und Eigenschaften erstellen
    lFont = GetFontFromFamilyName(FontCollection, FamilyName, FontSize, eFontStyle)

    ' ist ein Font-Objekt vorhanden
    If lFont <> 0& Then

        ' Graphics-Objekt vom DC
        If GdipCreateFromHDC(picRes.hDC, lGraphics) = OK Then

            ' einen Brush-Objekt erstellen
            If GdipCreateSolidFill(&HFF000000, lBrush) = OK Then

                ' ein StringFormat-Objekt erstellen
                If GdipCreateStringFormat(StringFormatFlagsDefault, LANG_NEUTRAL, _
                    lStringFormat) = OK Then
                    
                    ' hier knnen weitere GDI+ StringFormat-
                    ' und GDI+ Graphics-Eigenschaften gesetzt werden

                    ' Eigenschaft fr Graphics setzen
                    If GdipSetTextRenderingHint(lGraphics, _
                        TextRenderingHintAntiAlias) = OK Then

                        ' Eigenschaft fr Graphics setzen
                        If GdipSetSmoothingMode(lGraphics, _
                            SmoothingModeHighQuality) = OK Then

                            ' Rect fr die Textausgabe
                            With tRECTF
                                .Left = 10
                                .Top = 25
                                .Width = 400
                                .Height = 400
                            End With

                            ' Text zeichnen
                            Call GdipDrawString(lGraphics, StrPtr(sText), Len( _
                                sText), lFont, tRECTF, lStringFormat, lBrush)

                        End If

                    End If

                    ' Aufrumen
                    Call GdipDeleteStringFormat(lStringFormat)

                End If

                ' Aufrumen
                Call GdipDeleteBrush(lBrush)

            End If

            ' Aufrumen
            Call GdipDeleteGraphics(lGraphics)

        End If

        ' Aufrumen
        Call GdipDeleteFont(lFont)

    End If

End Sub

Private Function StartUpGDIPlus(ByRef Token As Long) As Status

    Dim GdipStartupInput As GDIPlusStartupInput
    Dim GdipStartupOutput As GdiplusStartupOutput

    GdipStartupInput.GdiPlusVersion = GdiPlusVersion

    StartUpGDIPlus = GdiplusStartup(Token, GdipStartupInput, _
        GdipStartupOutput)

End Function

Private Function ShutdownGDIPlus(ByVal Token As Long) As Status

    ShutdownGDIPlus = GdiplusShutdown(Token)

End Function
